#include <iostream>
#include <bits/stdc++.h>

using namespace std;

vector<vector<long long>> nodes;
vector<bool> secures;
vector<long long> stamWas;

void walk(long long stamina, long long node){
    secures[node]  = true;
    if (stamina == 0 || stamWas[node] >= stamina){
        return;
    }
    for (auto i : nodes[node]){
        walk(stamina - 1, i);
    }
}

int main()
{
    long long n, m, k;
    cin >> n >> m >> k;
    stamWas = vector<long long>(n, 0);
    nodes = vector<vector<long long>>(n, vector<long long>());
    secures = vector<bool>(n, false);
    for (long long i = 0; i < m; i ++){
        long long tmp1, tmp2;
        cin >> tmp1 >> tmp2;
        nodes[tmp1 - 1].push_back(tmp2 - 1);
        nodes[tmp2 - 1].push_back(tmp1 - 1);
    }
    for (long long i = 0; i < k; i ++){
        long long node, stam;
        cin >> node >> stam;
        walk(stam, node - 1);
    }
    vector<long long> ans;
    long long ln = 0;
    for (long long i = 0; i < n; i ++){
        if (secures[i]){
            ans.push_back(i + 1);
            ln ++;
        }
    }
    cout << ln << endl;
    for (auto i : ans){
        cout << i << ' ';
    }
}
